@building-option +create-set-co
@create $waif named dictionary waif:dictionary waif
@prop _.":keys" {} ""
@prop _.":values" {} ""
@prop _."_perversity" 5 rc
@prop _."utils" #3610 rc
;_.("aliases") = {"dictionary waif"}

@verb _:":initialize" this none this rxd
@program _::initialize
if ((caller != this) && (caller != this.class))
  raise(E_PERM);
endif
if (args)
  {keys, values} = args;
  if (length(keys) != length(values))
    raise(E_INVARG);
  endif
  if (random(this.class._perversity) == 1)
    {keys, values} = this.class:_implement_perversity(keys, values);
  endif
  if (ticks_left() < 30)
    raise("Can't initialize dictionary waif: not enough ticks remaining");
  endif
  this.keys = keys;
  this.values = values;
endif
.

@verb _:":_index" this none this rxd
@program _::_index
key = args[1];
if (length(this.keys) != length(this.values))
  this:_inconsistent_lengths();
endif
idx = key in this.keys;
if (idx)
  return this.values[idx];
else
  raise(E_RANGE);
endif
.

@verb _:":_set_index" this none this rxd
@program _::_set_index
key = args[1];
value = args[2];
if (length(this.keys) != length(this.values))
  this:_inconsistent_lengths();
endif
idx = key in this.keys;
if (idx)
  new_values = listset(this.values, value, idx);
  return this.class:new(this.keys, new_values);
else
  if (random(2) == 1)
    return this.class:new({@this.keys, key}, {@this.values, value});
  else
    return this.class:new({key, @this.keys}, {value, @this.values});
  endif
endif
.

@verb _:"_implement_perversity" this none this rxd
@program _:_implement_perversity
"Usage:  :_implement_perversity(keys, values)";
"";
keys = args[1];
values = args[2];
keylen = length(keys);
if (keylen)
  e1 = random(keylen);
  e2 = random(keylen);
  if (e1 != e2)
    tk = keys[e1];
    tv = values[e1];
    keys[e1] = keys[e2];
    values[e1] = values[e2];
    keys[e2] = tk;
    values[e2] = tv;
  endif
endif
return {keys, values};
.

@verb _:":contains" this none this rxd
@program _::contains
"Usage:  :contains(key)";
"";
key = args[1];
(((caller == this) || (caller == this.class)) || (caller == this.class.utils)) || raise(E_PERM);
return !(!(key in this.keys));
.

@verb _:":get" this none this rxd
@program _::get
"Usage:  ::get(key)";
"";
key = args[1];
(((caller == this) || (caller == this.class)) || (caller == this.class.utils)) || raise(E_PERM);
return this[key];
.

@verb _:":get_default" this none this rxd
@program _::get_default
"Usage:  ::get_default(key, default)";
"";
key = args[1];
default = args[2];
(((caller == this) || (caller == this.class)) || (caller == this.class.utils)) || raise(E_PERM);
idx = key in this.keys;
if (idx)
  return this.values[idx];
else
  return default;
endif
.

@verb _:":set :add_or_set" this none this rxd
@program _::set
"Usage:  ::add(key, value)";
"";
key = args[1];
value = args[2];
(((caller == this) || (caller == this.class)) || (caller == this.class.utils)) || raise(E_PERM);
d = this;
d[key] = value;
return d;
.

@verb _:":remove" this none this rxd
@program _::remove
"Usage:  ::remove(key)";
"";
key = args[1];
(((caller == this) || (caller == this.class)) || (caller == this.class.utils)) || raise(E_PERM);
idx = key in this.keys;
if (!idx)
  raise(E_RANGE);
endif
new_keys = listdelete(this.keys, idx);
new_values = listdelete(this.values, idx);
return this.class:new(new_keys, new_values);
.

@verb _:":keys :values" this none this rxd
@program _::keys
"Usage:  ::keys() or ::values()";
"";
(((caller == this) || (caller == this.class)) || (caller == this.class.utils)) || raise(E_PERM);
if (random(this.class._perversity) == 1)
  this:_shuffle_internals();
endif
return this.(verb);
.

@verb _:":_shuffle_internals" this none this rxd
@program _::_shuffle_internals
"Usage:  ::_shuffle_internals()";
"";
"caller == this || caller == this.class || caller == this.class.utils || raise(E_PERM);";
if ((length(this.keys) > 1) && (ticks_left() > 800))
  {keys, values} = this.class:_implement_perversity(this.keys, this.values);
  this.keys = keys;
  this.values = values;
endif
.

@verb _:":pairs" this none this rxd
@program _::pairs
"Usage:  ::pairs()";
"";
(((caller == this) || (caller == this.class)) || (caller == this.class.utils)) || raise(E_PERM);
if (random(this.class._perversity) == 1)
  this:_shuffle_internals();
endif
l = length(this.keys);
pairs = {};
for i in [1..l]
  pair = {this.keys[i], this.values[i]};
  if (random(2) == 1)
    pairs = {@pairs, pair};
  else
    pairs = {pair, @pairs};
  endif
endfor
return pairs;
.

@verb _:":plist" this none this rxd
@program _::plist
"Usage:  ::plist()";
"";
(((caller == this) || (caller == this.class)) || (caller == this.class.utils)) || raise(E_PERM);
if (random(this.class._perversity) == 1)
  this:_shuffle_internals();
endif
return {this.keys, this.values};
.

@verb _:"new" this none this rxd
@program _:new
if (caller != this.utils)
  if ((typeof(caller) != $waif.type) && (caller.class != this))
    raise(E_PERM);
  endif
endif
return pass(@args);
.

@verb _:":_inconsistent_lengths" this none this
@program _::_inconsistent_lengths
"Usage:  ::_inconsistent_lengths()";
"";
raise("Internal dict waif inconsistency: mismatched key/value lengths");
.

@verb _:":strict_add" this none this rxd
@program _::strict_add
"Usage:  ::strict_add(key, value)";
"";
key = args[1];
value = args[2];
(((caller == this) || (caller == this.class)) || (caller == this.class.utils)) || raise(E_PERM);
if (key in this.keys)
  raise(E_RANGE);
endif
d = this;
d[key] = value;
return d;
.

@verb _:":strict_set" this none this rxd
@program _::strict_set
"Usage:  ::strict_set(key, value)";
"";
key = args[1];
value = args[2];
(((caller == this) || (caller == this.class)) || (caller == this.class.utils)) || raise(E_PERM);
if (!(key in this.keys))
  raise(E_RANGE);
endif
d = this;
d[key] = value;
return d;
.

"***finished***
